//###########################################################################//
//
//Project :   Solid Works  v 0.75 Beta  for Ti 92+
//
//Author:  David Coz      
//
//Mail  :  coz.hubert@infonie.fr
//
// All the Options Menu Stuff
//
//Created 10/05/2002; 00:21:07
//
//############################################################################//







#include <tigcclib.h>         // Include All Header Files

char grille,perspective,save_option,auto_archiv;
int disto;



void menu(int x1,int y1,int x2,int y2,WINDOW* w1)
{
	WIN_RECT rect ={x1,y1,x2,y2};
  WinOpen(w1,&rect,WF_SAVE_SCR);
  WinBackground(w1,A_REVERSE);
  WinAttr(w1,A_NORMAL);
  WinFont(w1,F_4x6);
  WinActivate(w1);
  WinClr(w1);
}

int choose(int x_start,int y_start,int rec_width,int rec_height,int num_choice,WINDOW* w1,int previous)
{
	 int choice=previous,key=0;  
 while (key!=264)
  {
  WIN_RECT rect ={x_start,y_start+choice*10-10,rec_width,rec_height+choice*10-10};
 
  WinFill (w1,&rect, A_XOR); 
  key=ngetchx();	
  WinFill (w1,&rect, A_XOR); 
  
  if (key==13)
  return choice;
  if (key==344&&choice!=num_choice)
  {
   choice++;
   }
  if (key==338&&choice!=1)
  {
  	choice--;
  	}
  	
  }
  return 264;
}


void on_off(char *p)
{
WINDOW w2;
	int	key2=0;
     menu(95,52,145,76,&w2);
     WinStrXY(&w2,18,2,"ON");
		WinStrXY(&w2,18,12,"OFF");
		key2=choose(10,2,6,6,2,&w2,2-*p);
		 if (key2==1)
    *p=1;
     if (key2==2)
     *p=0;
     WinClose(&w2);
}

void options(void)
{
int key=1,key2;
WINDOW w1,w2;
menu(80,34,160,104,&w1);
while(key!=264)
{
WinStrXY(&w1,18,6,"PERSPECTIVE");
WinStrXY(&w1,20,16,"DISTORSION");
WinStrXY(&w1,21,26,"SHOW GRID");
WinStrXY(&w1,21,36,"Z-BUFFER");
WinStrXY(&w1,23,46,"CENTER");
WinStrXY(&w1,16,56,"AUTO ARCHIVE");


key=choose(2,4,72,12,6,&w1,key);

if (key==1)
  on_off(&perspective);  
    
if (key==2)
  {
  	WIN_RECT rect ={8,2,30,10};
  	   	key2=1;
      char buf[50];
         menu(100,44,140,82,&w2);
     WinStrXY(&w2,6,12,"MORE");
		WinStrXY(&w2,6,22,"LESS");
	
		while (key2!=264){
					sprintf(buf,"%d",disto);
			 WinFill (&w2,&rect, A_REVERSE); 
							WinStrXY(&w2,10,2,buf);
					key2=choose(2,10,30,20,2,&w2,key2);
		 if (key2==1&&disto!=1000)
    disto+=10;
     if (key2==2&&disto!=30)
     disto-=10;
      }
     WinClose(&w2);
  }
  
if (key==3)
  on_off(&grille) ; 
  
if (key==4)
  on_off(&default_z_buf);

if (key==5)
  {
  	key2=0;
     menu(95,52,145,76,&w2);
     WinStrXY(&w2,18,2,"USER");
		WinStrXY(&w2,18,12,"DEFAULT");
		key2=choose(10,2,6,6,2,&w2,2-center_defined);
		 if (key2==1)
   center_defined=1;
     if (key2==2)
    center_defined=0;
     WinClose(&w2);
  }


if (key==6)
  	on_off(&auto_archiv);
		
}
WinClose(&w1);
}

